/******************************************************************************
Marvin A. Biscocho
	CS 309
	December 3, 2002
	Professor B.L. Jahr Schaffrath
	Primal Dual Algorithm

  rational.h file
	Reduces fractions
	Displays as fractions not float
******************************************************************************/

// rational.h: declaration of Rational ADT
#ifndef RATIONAL_H
#define RATIONAL_H

#include <iostream>
#include <string>

using namespace std;
const int TRACE = 0;

// Rational ADT: class description
class Rational {
	public: // member functions
		// default constructor
		Rational();
		// another constructor
		Rational(int numer);
		// a second constructor
		Rational(int numer, int denom = 1);
		// some arithmetic and stream facilitators
		Rational Add(const Rational &r) const;
		Rational Subtract(const Rational &r) const;
		Rational Multiply(const Rational &r) const;
		Rational Divide(const Rational &r) const;
		void Insert(ostream &sout) const;
		void Extract(istream &sin);
	protected:
		// inspectors
		int GetNumerator() const;
		int GetDenominator() const;
		// mutators
		void SetNumerator(int numer);
		void SetDenominator(int denom);
	private:
		// data members
		int NumeratorValue;
		int DenominatorValue;
		void Reduce();                         // support function
		int gcd (int, int);                     // support function

};

Rational operator+(const Rational &r, const Rational &s);
Rational operator-(const Rational &r, const Rational &s);
Rational operator*(const Rational &r, const Rational &s);
Rational operator/(const Rational &r, const Rational &s);

ostream& operator<<(ostream &sout, const Rational &s);
istream& operator>>(istream &sin, Rational &r);

#endif

